/****************************
ע⣺1PSBʼսVcc,

2.ֵĶλʼΪ11
********************************/


#include <msp430x16x.h>
#include  "LCD.h"

#define LCD_DataIn    P5DIR=0x00//ݿڷΪ
#define LCD_DataOut   P5DIR=0xff//ݿڷΪ
#define LCD2MCU_Data  P5IN
#define MCU2LCD_Data  P5OUT
#define LCD_CMDOut    P4DIR|=0xe0	//P4ڵĸλΪ
#define LCD_RS_H      P4OUT|=BIT7	//P4.7
#define LCD_RS_L      P4OUT&=~BIT7	//P4.7
#define LCD_RW_H      P4OUT|=BIT6	//P4.6
#define LCD_RW_L      P4OUT&=~BIT6	//P4.6
#define LCD_EN_H      P4OUT|=BIT5       //P4.5
#define LCD_EN_L      P4OUT&=~BIT5	//P4.5
#define LCD_PSB_H     P3OUT|=BIT3      //P3.3
#define LCD_PSB_L     P3OUT&=~BIT3     //P3.3
#define LCD_RST_H     P3OUT|=BIT4      //P3.4
#define LCD_RST_L     P3OUT&=~BIT4     //P3.4



/*******************************************
ƣPlay_Cartoon
    ܣ
    time
ֵ  
********************************************/
void Play_Cartoon(uint time)
{
  int i=0,j=0;
  int x=128,y=64;
  for(;y>31;x--,y--)
  {
    for(;i<x;i++)
    {
    LCD_Draw_Point(i,j,1);
    Delay_Nus(time);
    }
    i--;
    for(;j<y;j++)
   {
    LCD_Draw_Point(i,j,1);
    Delay_Nus(time);
    }
    j--;
    for(;i>=128-x;i--)
   {
    LCD_Draw_Point(i,j,1);
    Delay_Nus(time);
    }
    i++;
    for(;j>64-y;j--)
   {
    LCD_Draw_Point(i,j,1);
    Delay_Nus(time);
    }    
    j++;
  }
}

/************ʱ**************************/
void Delay_Nms(uint n)
{
    uint i;
    
    for(i = n;i > 0;i--)    delay_ms(1);
}

/*********д******************************/
void Write_Cmd(uchar cmd)
{
    uchar lcdtemp = 0;
    LCD_RS_L;                //ѡ
    LCD_RW_H;       
    LCD_DataIn;  
    do                       //æ
    {    
        LCD_EN_H;
       	_NOP();					
       	lcdtemp = LCD2MCU_Data; 
       	LCD_EN_L;
        
    }
    while(lcdtemp & 0x80); 
    
    LCD_DataOut;    
    LCD_RW_L;  		
    MCU2LCD_Data = cmd; 
    LCD_EN_H;
    _NOP();						  			
    LCD_EN_L;
}

/*********д******************************/
void  Write_Data(uchar dat)
{
    uchar lcdtemp = 0;   
        
    LCD_RS_L;
    LCD_RW_H;  
    LCD_DataIn;   
    do                       //æ
    {    
        LCD_EN_H;
        _NOP();						
        lcdtemp = LCD2MCU_Data; 
        LCD_EN_L;      
    }
    while(lcdtemp & 0x80);  
    
    LCD_DataOut; 
    LCD_RS_H;      //ѡ
    LCD_RW_L;  
        
    MCU2LCD_Data = dat;
    LCD_EN_H;
    _NOP();
    LCD_EN_L;
}  
/***********ʼҺ****************************/
void Init_Lcd(void)
{  

    LCD_RS_L;
    LCD_RW_L;
    LCD_EN_L;
    delay_ms(1); 
    LCD_CMDOut;    //Һƶ˿Ϊ
     delay_ms(10);
    Write_Cmd(0x30);   //ѡָ
    Write_Cmd(0x02);   // ַλ
    Write_Cmd(0x0c);   //ʾ,αر
    Write_Cmd(0x01);   //ʾ
    Write_Cmd(0x06);   //α
    Write_Cmd(0x80);   //趨ʾʼַ
}

/*********
ܣ
   ݣ

***********/
uchar Read_Data()
{
    uchar lcdtemp = 0; 
    uchar data=0;
        
    LCD_RS_L;      
    LCD_RW_H;    
    LCD_DataIn;   
    do                       //æ
    {    
        LCD_EN_H;
        _NOP();						
        lcdtemp = LCD2MCU_Data; 
        LCD_EN_L;      
    }
    while(lcdtemp & 0x80);  
    LCD_DataIn;
    LCD_RS_H;     //ѡ
    LCD_RW_H;     //
    LCD_EN_H;     
    _NOP();
    data = LCD2MCU_Data;
    
    _NOP();
    LCD_EN_L;
    return data; 
}

/****************λ*********************/
void LCD_SetXY(uchar X, uchar Y) 
{
   switch(Y) {
		case 1: Write_Cmd(0x7F + X);break;
		case 2: Write_Cmd(0x8F + X);break;
		case 3: Write_Cmd(0x87 + X);break;
		case 4: Write_Cmd(0x97 + X);break;
	    }
}

/****************ָλʾĳַ****************/
void disp_char(unsigned char X, unsigned char Y, unsigned char wdata)
{
    LCD_SetXY(X, Y);
    Write_Data(wdata);
}

/***********
ܣָλʾַ
************/
void disp_str(unsigned char X, unsigned char Y, unsigned char *Str)
{
    unsigned char temp;
    LCD_SetXY(X, Y);
    temp = *Str;
    while(temp != 0)
    {
        Write_Data(temp);
        temp = *(++Str);
    }
}

/***********
ܣָλʾi-1λַ
************/
void disp_str_number(unsigned char X, unsigned char Y, unsigned char *Str,unsigned char i)
{
    unsigned char temp;
    LCD_SetXY(X, Y);
    temp = *Str;
    for(;i>0;i--)
    {
        Write_Data(temp+48);
        temp = *(++Str);
    }
}

/***********
ܣָλʾ,ݶλ,޸,λΪʾ
************/
void disp_str_Inumber(unsigned char X, unsigned char Y, uint num)
{
  
    disp_char(X,Y,num/1000+48);
    num-=((int)(num/1000))*1000;
    Write_Data(num/100+48);
    num-=((int)(num/100))*100;
    Write_Data(num/10+48);
    num-=((int)(num/10))*10;
    Write_Data(num+48);
}




/***********
ܣָλʾ,ʽΪxxxx.xx,޸,ܴ65535

************/
void disp_str_fnumber(unsigned char x, unsigned char y,float DATA)
{
                 uchar bai,shi,ge,shi_,bai_,qian_;
                 bai=(uint)(DATA/100);
		 shi=(uint)(DATA/10)%10;
		 ge=(uint)DATA%10;
		 shi_=(uint)(DATA*10)%10;
		 bai_=(uint)(DATA*100)%10;
		 qian_=(uint)(DATA*100)%10;
		 disp_char(x,y,bai+48);
		 Write_Data(shi+48);
		 Write_Data(ge+48);
		 Write_Data('.');
		 Write_Data(shi_+48);
		 Write_Data(bai_+48);
 }

/******************************************************/
void LCD_message(uchar * q,uchar Y,uchar length)
{
   uchar a[17],i=0,y=Y;
   while(length)
   {
     while(length>1&&i<16)
     { 
       if(*q>0x7f)
       {
         a[i++]=*(q++);
         a[i++]=*(q++);
         length-=2;
       }     
       else if((*q<=0x7f)&&(*(q+1)>0x7f))
      {
             a[i++]=*(q++);
             a[i++]=32;
             length--;
      }
      else 
        {
         a[i++]=*(q++);
         a[i++]=*(q++);
         length-=2;
       } 
     }
     if(i==16||length==0)a[i]=0;
     else if(length==1)
     {
          a[i++]=*(q++);
          a[i++]=32;
          length--;
          a[i]=0;
     }
     disp_str(1,y++,a);
     i=0;
   }
}
//data1=0xff,data2=0xffʱ,x0,y0ʾ16xl*yl.
//data1=0xff,data2=0x00ʱ,x0,y0ǰ뷴ʾ8xl*yl.
//data1=0x00,data2=0xffʱ,x0,y0뷴ʾ8xl*yl.
/**********
ܣƹʾ

***********/
void con_disp (uchar data1,uchar data2,uchar x0,uchar y0,uchar xl,uchar yl)
{
  uchar i,j;
  for(j=0;j<yl;j++)
  {
    for(i=0;i<xl;i++)
    {
      Write_Cmd(0x34);
      Write_Cmd(y0+j);
      Write_Cmd(x0+i);
      Write_Cmd(0x30);
      Write_Data(data1);
      Write_Data(data2);
    }
  }
      Write_Cmd(0x36);
      Write_Cmd(0x30);
}
/*--------------------------------------------*/
//data1=0xff,data2=0x00ʱ,x0,y0ʾǰ.
//data1=0x00,data2=0xffʱ,x0,y0ʾ.
//data1=0x00,data2=0x00ʱ,x0,y0ʾ.
//y0=0x8f or y0=0x9f.
/********
ܣ


**********/
void cur_disp (uchar data1,uchar data2,uchar x0,uchar y0)
{
   Write_Cmd(0x34);
   Write_Cmd(y0);
   Write_Cmd(x0);
   Write_Data(data1);
   Write_Data(data2);
   Write_Cmd(0x36);
   Write_Cmd(0x30);
}

//ƶ귴׺
//state=00      
//state=01      Ҳ෴
//state=10      ෴
//state=11      ȫ
/********
ܣ


********/
void LCD_Turn_Over(uchar X,uchar Y,uchar num,uchar state)
{
     switch(Y) {
		case 1:
			X=0x7F + X;
                              Y=0x80;
			break;
		case 2:
			X=0x7F + X;
                              Y=0x90;
			break;
		case 3:
			X=0x87 + X;
                              Y=0x80;
			break;
		case 4:
			X=0x87 + X;
                              Y=0x90;
                              break;
	}
   switch (state)
       {
               case 0: 
                      con_disp (0x00,0x00,X,Y,num,16);
                      break;
               case 1: 
                      con_disp (0x00,0xff,X,Y,num,16);
                      break;
               case 2: 
                      con_disp (0xff,0x00,X,Y,num,16);
                      break;
               case 3: 
                      con_disp (0xff,0xff,X,Y,num,16);
                      break;   
       }
}

//ƶα꺯
//state=00      
//state=01      Ҳα
//state=10      α
//state=11      ȫα
void LCD_Cursor(uchar X,uchar Y,uchar state)
{
       switch(Y) {
		case 1:
			X=0x7F + X;
                        Y=0x8f;
			break;
		case 2:
			X=0x7F + X;
                        Y=0x9f;
			break;
		case 3:
			X=0x87 + X;
                        Y=0x8f;
			break;
		case 4:
			X=0x87 + X;
                        Y=0x9f;
                        break;
	}
       
      switch(state) {
		case 0:
			cur_disp (0x00,0x00,X,Y);
			break;
		case 1:
			cur_disp (0x00,0xff,X,Y);
			break;
		case 2:
			cur_disp (0xff,0x00,X,Y);
			break;
		case 3:
			cur_disp (0xff,0xff,X,Y);
                        break;
	}

}

/***********ͼ****************************/
void LCD_Draw_Clear(void)
{
 unsigned char itemp,jtemp;
 unsigned char X = 0x80,Y=0x80;
 Write_Cmd(0x0c); //ʾ,αر
 Write_Cmd(0x34); //ʾչָ
 for (itemp=0;itemp<64;itemp++) 
 {
   for(jtemp=0;jtemp<8;jtemp++)
   { 
      Write_Cmd(Y);  //趨ʾʼַ
      Write_Cmd(X);
      Write_Data(0x00);
      Write_Data(0x00);
      X++;
   }
   Y++;
   if(Y>0x9f)  
        Y=0x80;
  X=0x80+(((itemp+1)>>5)<<3);//0x88   
 }
  //Write_Cmd(0x36);  
  Write_Cmd(0x30); //ѡָ                    
}

/***************ͼ**************************/
void Draw_PM(const uchar *ptr)
{
    uchar i,j,k;
    
    Write_Cmd(0x34);        //չָ
    i = 0x80;            
    for(j = 0;j < 32;j++)
    {
      Write_Cmd(i++);
      Write_Cmd(0x80);
      for(k = 0;k < 16;k++)
      {
          Write_Data(*ptr++);
      }
    }
    i = 0x80;
    for(j = 0;j < 32;j++)
    {
      Write_Cmd(i++);
      Write_Cmd(0x88);	   
      for(k = 0;k < 16;k++)
      {
          Write_Data(*ptr++);
      } 
    }  
    Write_Cmd(0x36);        //򿪻ͼʾ
    Write_Cmd(0x30);        //صָ
}
/**************************
ܣ


***********************/
void LCD_Draw_Point( uchar X,uchar Y,uchar Color )
{
    uchar Row,Tier,Tier_bit;//
    uchar ReadOldH,ReadOldL;//
    Write_Cmd(0x34);//ָ
    Write_Cmd(0x36);
    Tier= X >> 4 ;  //Tier ΪX16
    Tier_bit = X & 0x0f ;
    if( Y < 32 )//λxΪ063yΪ07
    {
        Row = Y ;
    }
    else
    {
        Row = Y - 32 ;
        Tier += 8 ;
    }
    Write_Cmd( Row + 0x80 );//еĵַ
    Write_Cmd( Tier + 0x80 );//еĵַ
    Read_Data();//õݣ״̬
    ReadOldH = Read_Data(); 
    ReadOldL = Read_Data(); 
    Write_Cmd( Row + 0x80 );
    Write_Cmd( Tier + 0x80 );
    if( Tier_bit < 8 )
    {
        switch( Color)
        {
            case 0 : ReadOldH &=(~( 0x01 << ( 7 - Tier_bit ))); break ;
            case 1 : ReadOldH |= ( 0x01 << ( 7 - Tier_bit )) ; break ;
            case 2 : ReadOldH ^= ( 0x01 << ( 7 - Tier_bit )) ; break ;
            default: break ;    
        }
        Write_Data( ReadOldH ) ;
        Write_Data( ReadOldL ) ;
    }
    else
    {
        switch(Color)
        {
            case 0 : ReadOldL &= (~( 0x01 << ( 15 - Tier_bit )));break ;
            case 1 : ReadOldL |= ( 0x01 << ( 15 - Tier_bit )) ; break ;
            case 2 : ReadOldL ^= ( 0x01 << ( 15 - Tier_bit )) ; break ;
            default : break ;
        }
       Write_Data( ReadOldH );
       Write_Data( ReadOldL );
    }
    Write_Cmd(0x30);
}
//ˮƽ
void LCD_Draw_Line_x( uchar X0, uchar X1, uchar Y, uchar Color )
{   
    uchar Temp ;
    if( X0 > X1 )
    {
        Temp = X1 ;
        X1 = X0 ;
        X0 = Temp ;
    }
    for( ; X0 <= X1 ; X0++ )
    LCD_Draw_Point( X0, Y, Color );    
}
//ֱ עY
void LCD_Draw_Line_Y( uchar X, uchar Y0, uchar Y1, uchar Color )
{                                                                              
    uchar Temp ;
    if( Y0 > Y1 )
    {
        Temp = Y1 ;
        Y1 = Y0 ;
        Y0 = Temp ;
    }
    for(; Y0 <= Y1 ; Y0++)
    LCD_Draw_Point( X, Y0, Color);
}
//б
void LCD_Draw_Line( uchar StartX, uchar StartY, uchar EndX, uchar EndY, uchar Color )
{
    int distance;      /*ĻСı(Ϊint)*/
    int delta_x, delta_y ;
    int incx, incy ;
do{
    delta_x = EndX - StartX ;
    delta_y = EndY - StartY ;
    if( delta_x > 0 )
    {
        incx = 1;
    }
    else if( delta_x == 0 )
    {
       incx = 0;
    }
    else
    {
        incx = -1 ;
    }
    if( delta_y > 0 )
    {
        incy = 1 ;
    }
    else if(delta_y == 0 )
    { 
       incy = 0 ;
    }
    else
    {
        incy = -1 ;
    }
    delta_x = incx * delta_x ;    
    delta_y = incy * delta_y ;
    
    if( delta_x > delta_y )
   {
     distance = delta_x ;
     StartX+=incx;
     StartY+=incy;
   }
   else
   {
     distance = delta_y;
     StartX+=incx;
     StartY+=incy;
   }
   LCD_Draw_Point( StartX, StartY, Color ); 
}while(distance!=0);
}

